<template>
	<div class="calendar">

		<div class="calendar__head" v-for="weekday in weekdayNames" :key="weekday">{{ weekday.substr(0, 2) }}</div>

<!--		Days of the previous month-->
		<div v-for="(field, index) in calendar.last" :key="'last-' + index" class="calendar__blank">
			<div class="calendar__day-nr">{{ index }}</div>
		</div>

<!--		Days of the current month-->
		<div v-for="(field, index) in calendar.this" :key="'this-' + index" :class="{ 'calendar__day--today' : isToday(index),  'calendar__day--mobile-collapsed' : !field.id }"  class="calendar__day">
			<div class="calendar__day-nr">

				<span v-if="field.id" class="calendar__weekday">{{ weekdayNames[getWeekdayAsNumber(index)] }}</span>
				<router-link v-else-if="isAdmin" :to="'/admin/events/new/' + computedYear + '-' + computedMonth + '-' + index" class="calendar__add" title="Event hinzufügen"></router-link>
				<router-link v-else :to="'/bookings/' + computedYear + '-' + computedMonth + '-' + index" class="calendar__add" title="Anfrage senden"></router-link>

				{{ index }}
			</div>
			<router-link v-if="field.id" custom v-slot="{ navigate }"  :to="'/event/' + field.id" class="calendar__event">
				<div @click="navigate" @keypress.enter="navigate" role="link">
					<div class="calendar__event__flyer" :style="{'background-image' : 'url(' + baseUrl + '/program/' +  field.image + ')'}"></div>
					<div class="calendar__event__title">
						{{ field.title }}
					</div>
				</div>
			</router-link>
		</div>

<!--		Days of the following month-->
		<div v-for="(field, index) in calendar.next" :key="'next-' + index" class="calendar__blank">
			<div class="calendar__day-nr">{{ index }}</div>
		</div>

	</div>
</template>

<script>
export default {
	name: "EventCalendar",
	data: () => ({
	}),
	props: {
		weekdayNames: [],
		computedYear: String,
		computedMonth: String,
		calendar: {}
	},
	methods: {
		isToday(day) {
			const date = new Date();
			return parseInt(this.computedYear) === date.getFullYear() && parseInt(this.computedMonth) === date.getMonth() + 1 && parseInt(day) === date.getDate();
		},

		getWeekdayAsNumber(day) {
			let weekday = new Date(this.computedYear + "-" + this.computedMonth + "-" + day).getDay() - 1;
			return weekday >= 0 ? weekday : 6;
		}
	},
	mounted() {
	},
	computed: {
		isAdmin() {
			return this.$store.getters.isAdmin;
		},
		baseUrl() {
			return process.env.VUE_APP_BASE_URL;
		}
	}
}
</script>

<style src="../assets/styles/calendar.css">
</style>